/*******************************************************************************
*
*   Given a prompt,  the number of loose items (1 to 22) and the loose item to
*   be pointed to (numbered from 0) followed by the appropriate number of item
*   strings (up to 20 characters), this function pulls down a confirmation menu.
*
*   An ESC returns -1, while a hit, do or selection by first character returns
*   the item number. Note: the first character of each item string should be
*   Upper Case.
*
*******************************************************************************/

#include <stdio.h>
#include <qdos.h>
/* #include <ios1.h> */
#include <qptr.h>
#include <stdarg.h>
#include <string.h>

static long ACHOICE();
static struct WM_action achoice = {JSR, wm_actli, ACHOICE};
extern char charac_size;


int menu_choice_m(prompt, nlitm, itptr, litm0) char *prompt; int nlitm;
                                        int itptr; char *litm0;
{
   va_list nxlitm;
   char *itxt;
   int icount;
   short pulld_wid, pr_wid, lit_wid;

#define pr_max 60
   static QD_TEXT(pr_max) _prompt;
#define litm_max 20
#define nlitm_max 22
   static QD_TEXT(litm_max) _litm[nlitm_max];

#define pulld_min 48
#define pulld_hgt 56
#define bord_x 4

   struct WM_wstat ws; /* this time ws is initialised in code */

   static struct WM_info info[1+1] =   /* information objects */
   {
    {6,10,                  /* xsize, ysize         size */
     (pulld_min-6)/2,0,     /* xorg, yorg           and origin */
     TYP_TEXT,0,            /* type, spare          item type */
     {CL_IINK,0,0},         /* ink, cwid, chgt      character attributes */
     &_prompt}              /* *pobj                pointer to object */

   ,{-1}                    /* end of array */
   };

   static struct WM_infw infw[2+1] =  /* information window */
   {
    {pulld_min,10,          /* xsize, ysize         size */
     bord_x,1,              /* xorg, yorg           and origin */
     NO_WCLEAR,             /* flag                 no clear + shadow */
     0,0,CL_MBACK,          /* borw, borc, papr     border width/clr, paper */
     info}                  /* *pobj                pointer to object list */

    ,{pulld_min,12,          /* xsize, ysize         size */
     bord_x,13,             /* xorg, yorg           and origin */
     NO_WCLEAR,             /* flag                 no clear + shadow */
     1,CL_IBORD,CL_MBACK,   /* borw, borc, papr     border width/clr, paper */
     NULL}                  /* *pobj                pointer to object list */

    ,{-1}                    /* end of array */
   };

   static struct WM_litm litm[nlitm_max+1] =   /* loose item */
   {
    {6,10,                  /* xsize, ysize         size */
     4,14,                  /* xorg, yorg           and origin */
     0,0,                   /* xjst, yjst           justification */
     TYP_TEXT-1,0,          /* type, skey           type and select key */
     &_litm[0],             /* *pobj                pointer to object */
     0,                     /* item                 item number */
     &achoice}              /* *pact                pointer to action */

    ,{6,10,                  /* xsize, ysize         size */
     4,14,                  /* xorg, yorg           and origin */
     0,0,                   /* xjst, yjst           justification */
     TYP_TEXT-1,0,          /* type, skey           type and select key */
     &_litm[1],             /* *pobj                pointer to object */
     1,                     /* item                 item number */
     &achoice}              /* *pact                pointer to action */

    ,{6,10,                  /* xsize, ysize         size */
     4,14,                  /* xorg, yorg           and origin */
     0,0,                   /* xjst, yjst           justification */
     TYP_TEXT-1,0,          /* type, skey           type and select key */
     &_litm[2],             /* *pobj                pointer to object */
     2,                     /* item                 item number */
     &achoice}              /* *pact                pointer to action */

    ,{6,10,                  /* xsize, ysize         size */
     4,14,                  /* xorg, yorg           and origin */
     0,0,                   /* xjst, yjst           justification */
     TYP_TEXT-1,0,          /* type, skey           type and select key */
     &_litm[3],             /* *pobj                pointer to object */
     3,                     /* item                 item number */
     &achoice}              /* *pact                pointer to action */

    ,{6,10,                  /* xsize, ysize         size */
     4,14,                  /* xorg, yorg           and origin */
     0,0,                   /* xjst, yjst           justification */
     TYP_TEXT-1,0,          /* type, skey           type and select key */
     &_litm[4],             /* *pobj                pointer to object */
     4,                     /* item                 item number */
     &achoice}              /* *pact                pointer to action */

    ,{6,10,                  /* xsize, ysize         size */
     4,14,                  /* xorg, yorg           and origin */
     0,0,                   /* xjst, yjst           justification */
     TYP_TEXT-1,0,          /* type, skey           type and select key */
     &_litm[5],             /* *pobj                pointer to object */
     5,                     /* item                 item number */
     &achoice}              /* *pact                pointer to action */

    ,{6,10,                  /* xsize, ysize         size */
     4,14,                  /* xorg, yorg           and origin */
     0,0,                   /* xjst, yjst           justification */
     TYP_TEXT-1,0,          /* type, skey           type and select key */
     &_litm[6],             /* *pobj                pointer to object */
     6,                     /* item                 item number */
     &achoice}              /* *pact                pointer to action */

    ,{6,10,                  /* xsize, ysize         size */
     4,14,                  /* xorg, yorg           and origin */
     0,0,                   /* xjst, yjst           justification */
     TYP_TEXT-1,0,          /* type, skey           type and select key */
     &_litm[7],             /* *pobj                pointer to object */
     7,                     /* item                 item number */
     &achoice}              /* *pact                pointer to action */

    ,{6,10,                  /* xsize, ysize         size */
     4,14,                  /* xorg, yorg           and origin */
     0,0,                   /* xjst, yjst           justification */
     TYP_TEXT-1,0,          /* type, skey           type and select key */
     &_litm[8],             /* *pobj                pointer to object */
     8,                     /* item                 item number */
     &achoice}              /* *pact                pointer to action */

    ,{6,10,                  /* xsize, ysize         size */
     4,14,                  /* xorg, yorg           and origin */
     0,0,                   /* xjst, yjst           justification */
     TYP_TEXT-1,0,          /* type, skey           type and select key */
     &_litm[9],             /* *pobj                pointer to object */
     9,                     /* item                 item number */
     &achoice}              /* *pact                pointer to action */

    ,{6,10,                  /* xsize, ysize         size */
     4,14,                  /* xorg, yorg           and origin */
     0,0,                   /* xjst, yjst           justification */
     TYP_TEXT-1,0,          /* type, skey           type and select key */
     &_litm[10],             /* *pobj                pointer to object */
     10,                     /* item                 item number */
     &achoice}              /* *pact                pointer to action */

    ,{6,10,                  /* xsize, ysize         size */
     4,14,                  /* xorg, yorg           and origin */
     0,0,                   /* xjst, yjst           justification */
     TYP_TEXT-1,0,          /* type, skey           type and select key */
     &_litm[11],             /* *pobj                pointer to object */
     11,                     /* item                 item number */
     &achoice}              /* *pact                pointer to action */

    ,{6,10,                  /* xsize, ysize         size */
     4,14,                  /* xorg, yorg           and origin */
     0,0,                   /* xjst, yjst           justification */
     TYP_TEXT-1,0,          /* type, skey           type and select key */
     &_litm[12],             /* *pobj                pointer to object */
     12,                     /* item                 item number */
     &achoice}              /* *pact                pointer to action */

    ,{6,10,                  /* xsize, ysize         size */
     4,14,                  /* xorg, yorg           and origin */
     0,0,                   /* xjst, yjst           justification */
     TYP_TEXT-1,0,          /* type, skey           type and select key */
     &_litm[13],             /* *pobj                pointer to object */
     13,                     /* item                 item number */
     &achoice}              /* *pact                pointer to action */

    ,{6,10,                  /* xsize, ysize         size */
     4,14,                  /* xorg, yorg           and origin */
     0,0,                   /* xjst, yjst           justification */
     TYP_TEXT-1,0,          /* type, skey           type and select key */
     &_litm[14],             /* *pobj                pointer to object */
     14,                     /* item                 item number */
     &achoice}              /* *pact                pointer to action */

    ,{6,10,                  /* xsize, ysize         size */
     4,14,                  /* xorg, yorg           and origin */
     0,0,                   /* xjst, yjst           justification */
     TYP_TEXT-1,0,          /* type, skey           type and select key */
     &_litm[15],             /* *pobj                pointer to object */
     15,                     /* item                 item number */
     &achoice}              /* *pact                pointer to action */

    ,{6,10,                  /* xsize, ysize         size */
     4,14,                  /* xorg, yorg           and origin */
     0,0,                   /* xjst, yjst           justification */
     TYP_TEXT-1,0,          /* type, skey           type and select key */
     &_litm[16],             /* *pobj                pointer to object */
     16,                     /* item                 item number */
     &achoice}              /* *pact                pointer to action */

    ,{6,10,                  /* xsize, ysize         size */
     4,14,                  /* xorg, yorg           and origin */
     0,0,                   /* xjst, yjst           justification */
     TYP_TEXT-1,0,          /* type, skey           type and select key */
     &_litm[17],             /* *pobj                pointer to object */
     17,                     /* item                 item number */
     &achoice}              /* *pact                pointer to action */

    ,{6,10,                  /* xsize, ysize         size */
     4,14,                  /* xorg, yorg           and origin */
     0,0,                   /* xjst, yjst           justification */
     TYP_TEXT-1,0,          /* type, skey           type and select key */
     &_litm[18],             /* *pobj                pointer to object */
     18,                     /* item                 item number */
     &achoice}              /* *pact                pointer to action */

    ,{6,10,                  /* xsize, ysize         size */
     4,14,                  /* xorg, yorg           and origin */
     0,0,                   /* xjst, yjst           justification */
     TYP_TEXT-1,0,          /* type, skey           type and select key */
     &_litm[19],             /* *pobj                pointer to object */
     19,                     /* item                 item number */
     &achoice}              /* *pact                pointer to action */

    ,{6,10,                  /* xsize, ysize         size */
     4,14,                  /* xorg, yorg           and origin */
     0,0,                   /* xjst, yjst           justification */
     TYP_TEXT-1,0,          /* type, skey           type and select key */
     &_litm[20],             /* *pobj                pointer to object */
     20,                     /* item                 item number */
     &achoice}              /* *pact                pointer to action */

    ,{6,10,                  /* xsize, ysize         size */
     4,14,                  /* xorg, yorg           and origin */
     0,0,                   /* xjst, yjst           justification */
     TYP_TEXT-1,0,          /* type, skey           type and select key */
     &_litm[21],             /* *pobj                pointer to object */
     21,                     /* item                 item number */
     &achoice}              /* *pact                pointer to action */

    ,{-1}                    /* end of array */
   };

   static struct WM_wwork ww = /* window working definition */
   {
     NULL,                  /* *wstat;              pointer to status area */
     NULL,                  /* *wscale              this was pointer to WDEF */
     0,                     /* chid                 channel ID */
     NULL,                  /* *pprec               pointer to pointer record */
     0,                     /* psave                pointer position saved */
     0,0,0,0,               /* 4 zero */
     NULL,                  /* *splst               pointer to sprite list */

     pulld_min+bord_x*2,pulld_hgt,  /* xsize, ysize */
     0,0, /* xorg, yorg           and origin */
     2,                     /* flag                 no clear + shadow */
     1,CL_MBORD,CL_MBACK,   /* borw, borc, papr     border width/clr, paper */
     NULL,                  /* *sprite              pointer to sprite */

     1,CL_MHIGH,            /* curw, curc           current item width/clr */

     CL_MPUNAV,CL_MIUNAV,NULL,NULL,  /* uback, uink, *ublob, *upatt  unavail */
     CL_MPAVBL,CL_MIAVBL,NULL,NULL,  /* aback, aink, *ablob, *apatt  avail */
     CL_MPSLCT,CL_MISLCT,NULL,NULL,  /* sback, sink, *sblob, *spatt  selected */

     NULL,                  /* *help */

     2,1,infw,              /* ninfo, ninob, *pinfo info winds */
     22,litm,                /* nlitm, *plitm        loose items */
     0,NULL                 /* nappl  *pappl        appl winds */
   };


   ws.wwork=&ww;  /* cross references */
   ww.wstat=&ws;

   QD_STXT (_prompt, prompt, pr_max);      /* title string */

   for (va_start (nxlitm,itptr), icount=0, lit_wid=0;
                         icount<nlitm; icount++)
   {
      itxt=va_arg (nxlitm, char *);          /* generalised itxt=*nxlitm++ */
      QD_STXT (_litm[icount], itxt, litm_max);          /* loose item string */
      if (_litm[icount].len > lit_wid) lit_wid=_litm[icount].len;
   }

   pulld_wid = (lit_wid * charac_size + 10);
          /* first guess at width */
          /* includes one character spare + loose item border for each item */
   pulld_wid *=4; /* four columns */
   pr_wid=(_prompt.len+1) * charac_size;
   if (pr_wid > pulld_wid) pulld_wid=pr_wid;
          /* but make sure that there is enough room for the prompt */

   pulld_wid = ((pulld_wid+11)/12)*12;
                                        /* nice size for 1-4,6 */
   lit_wid = (pulld_wid /4)- 4 ;   /* width of each item */

   ww.xsize = pulld_wid + (bord_x*2);        /* allow inner border on window */
   ww.ysize = 14+14+((nlitm-1)>>2) * 14;
   ww.nlitm = (short)nlitm;                  /* number of loose items */
   ww.xorg = pulld_wid/2;  /* pointer here */
   ww.yorg = 10;

   infw[0].xsize = pulld_wid;                    /* size of title window */
   info[0].xsize = pr_wid-6;                     /* size and position of */
   info[0].xorg = (pulld_wid - pr_wid) / 2 + 3 ; /* .. title 1/2 char at left */

   infw[1].xsize = pulld_wid;
   infw[1].ysize = 12+((nlitm-1)>>2) * 14;
   for (icount=0; icount<nlitm; icount++)
   {
      litm[icount].xsize = lit_wid;                     /* set item size */
      litm[icount].xorg = bord_x+2 + (icount&3) * (lit_wid + 4);   /* origin */
      litm[icount].yorg = 14 + (icount>>2) * (10 + 4);   /* origin */
      litm[icount].skey = _litm[icount].chrs[0];        /* select key */
      ws.litem[icount] = 0;                             /* and status */
   }
   litm[nlitm].xsize = -1;  /* ensure that there is a -1 at end of list */

   ws.citem = -1;                   /* no current item  */
   ws.ciact = NULL;                 /* or current item routine */
   ws.litem[nlitm_max] = -1;        /* preset ESC return */

   wm_pulld (&ww,-1,-1);               /* pull down */
   wm_wdraw (&ww);

   while (!wm_rptr(&ww)) {if (ws.evnt & PT_CAN) break;}

   wm_cluns (&ww);                   /* throw it away */

   return ws.litem[nlitm_max];      /* return code number */
}

static long ACHOICE (wwk,li,wst) struct WM_wwork *wwk; struct WM_litm *li; struct WM_wstat *wst;
{
   wst->litem[nlitm_max]=li->item;  /* set item hit in status area */
   return PT__CAN;                  /* and return CAN event */
}
